{$include lem_directives.inc}

unit LemStrings;

interface

uses
  LemCore;

// version 0.8.0.0 added optional overriding with LVL files  

const
  SVersion = '0.8.0.0';

  //@styledef
  SCheatCode =
  {$ifdef orig}
    'cheatcodes';
  {$endif}
  {$ifdef ohno}
    'cheatcodes';
  {$endif}
  {$ifdef h93}
    'cheatcodes';
  {$endif}
  {$ifdef remake}
    'cheatcodes';
  {$endif}

resourcestring
  SProgramName = 'LemmixPlayer Beta';
  SDummyString = '';

  {-------------------------------------------------------------------------------
    Errors
  -------------------------------------------------------------------------------}
  SMetaPieceLoadError = 'MetaPiece LoadFromStream is not defined';
  SVgaSpecDimensionError_dd = 'Special Dos level graphics must be %d x %d pixels';

  {-------------------------------------------------------------------------------
    MenuScreen
  -------------------------------------------------------------------------------}
  //@styledef
  SProgramText =
  {$ifdef language_english}
    {$ifdef orig}
    'Lemmings Clone (' + SVersion + ')' + #13 +
    {$endif}
    {$ifdef ohno}
    'Oh No More Lemmings! Clone (' + SVersion + ')' + #13 +
    {$endif}
    {$ifdef H93}
    'Holiday Lemmings 93 Clone (' + SVersion + ')' + #13 +
    {$endif}
    {$ifdef remake}
    'Lemmings Remake (' + SVersion + ')' + #13 +
    {$endif}
    'By Eric Langedijk';
  {$endif}
  {$ifdef language_dutch}
    {$ifdef orig}
    'Lemmings Kloon (' + SVersion + ')' + #13 +
    {$endif}
    {$ifdef ohno}
    'Oh No More Lemmings! Kloon (' + SVersion + ')' + #13 +
    {$endif}
    {$ifdef H93}
    'Holiday Lemmings 93 Clone (' + SVersion + ')' + #13 +
    {$endif}
    {$ifdef remake}
    'Lemmings Remake (' + SVersion + ')' + #13 +
    {$endif}
    'Door Eric Langedijk';
  {$endif}

  // max size for string that fits in the scrolling reel = 34
  // 1234567890123456789012345678901234

  SCredits =
  {$ifdef language_english}
    'Thanks to...' + #13 +
    'DMA for the original game' + #13 +
    'ccexplore for game-mechanics' + #13 +
    'Alex A. Denisov for Graphics32' + #13 +
    'Erik Turner for ZLibEx' + #13 +
    'Peter Morris for FastStrings' + #13 +
    'Un4seen Development for Bassmod at' + #13 +
    'http://www.un4seen.com' + #13 +
    'The Lemmings Forums at' + #13 +
    'http://Lemmings.isamedia.org' + #13 +
    'Volker Oth, ccexplore and Mindless for sharing sourcecode, resources ' +
    'and technical information about lemmings' + #13 +
    'Original credits...'  + #13 +
    'Lemmings By DMA Design'  + #13 +
    'Programming By Russell Kay'  + #13 +
    'Animation By Gary Timmons'  + #13 +
    'Graphics By Scott Johnston'  + #13 +
    'Music By Brian Johnston & Tim Wright'  + #13 +
    'PC Music By Tony Williams'  + #13 +
    'Copyright 1991 Psygnosis Ltd.';
  {$endif}
  {$ifdef language_dutch}
    'Met dank aan...';
  {$endif}

  {-------------------------------------------------------------------------------
    LevelCodeScreen
  -------------------------------------------------------------------------------}
  SEnterCode =
  {$ifdef language_english}
    'Enter Code';
  {$endif}
  {$ifdef language_dutch}
    'Geef Code';
  {$endif}

  SIncorrectCode =
  {$ifdef language_english}
    'INCORRECT CODE';
  {$endif}
  {$ifdef language_dutch}
    'FOUTE CODE';
  {$endif}

  SCodeForLevel_sd =
  {$ifdef language_english}
    'Code for %s' + #13 +
    'Level %d';
  {$endif}
  {$ifdef language_dutch}
    'Code voor %s' + #13 +
    'Spel %d';
  {$endif}

  {-------------------------------------------------------------------------------
    PreviewScreen
  -------------------------------------------------------------------------------}
  SPreviewString =
  {$ifdef language_english}
    'Level %d ' + '%s'                     + #13#13#13 +
    '          Number of Lemmings %d'      + #13#13 +
    '          %s To Be Saved'             + #13#13 +
    '          Release Rate %d'            + #13#13 +
    '          Time %d Minutes'            + #13#13 +
    '          Rating  %s'                 + #13#13#13 +
    '     Press mouse button to continue';
  {$endif}
  {$ifdef language_dutch}
    'Spel %d ' + '%s'                      + #13#13#13 +
    '          Aantal lemmings %d'         + #13#13 +
    '          %s Moet Gered'              + #13#13 +
    '          Snelheid %d'                + #13#13 +
    '          Tijd %d Minuten'            + #13#13 +
    '          Nivo %s'                    + #13#13#13 +
    '     Klik muis knop om door te gaan';
  {$endif}


  {-------------------------------------------------------------------------------
    Game Screen Info Panel
  -------------------------------------------------------------------------------}
  SSkillPanelTemplate =
  {$ifdef language_english}
    '..............' + 'OUT_.....' + 'IN_.....' + 'TIME_.-..';
  {$endif}
  {$ifdef language_dutch}
    '..............' + 'UIT_.....' + 'IN_.....' + 'TIJD_.-..';
  {$endif}

  SAthlete =
  {$ifdef language_english}
    'Athlete';
  {$endif}
  {$ifdef language_dutch}
    'Atleet';
  {$endif}

  SWalker =
  {$ifdef language_english}
    'Walker';
  {$endif}
  {$ifdef language_dutch}
    'Loper';
  {$endif}

  SJumper =  
  {$ifdef language_english}
    'Jumper';
  {$endif}
  {$ifdef language_dutch}
    'Springer';
  {$endif}

  SDigger =
  {$ifdef language_english}
    'Digger';
  {$endif}
  {$ifdef language_dutch}
    'Graver';
  {$endif}

  SClimber =
  {$ifdef language_english}
    'Climber';
  {$endif}
  {$ifdef language_dutch}
    'Klimmer';
  {$endif}

  SDrowner =
  {$ifdef language_english}
    'Drowner';
  {$endif}
  {$ifdef language_dutch}
    'Verdrinker';
  {$endif}

  SHoister =
  {$ifdef language_english}
    'Hoister';
  {$endif}
  {$ifdef language_dutch}
    'Hijser';
  {$endif}

  SBuilder =
  {$ifdef language_english}
    'Builder';
  {$endif}
  {$ifdef language_dutch}
    'Bouwer';
  {$endif}

  SBasher =
  {$ifdef language_english}
    'Basher';
  {$endif}
  {$ifdef language_dutch}
    'Breker';
  {$endif}

  SMiner =
  {$ifdef language_english}
    'Miner';
  {$endif}
  {$ifdef language_dutch}
    'Hakker';
  {$endif}

  SFaller =
  {$ifdef language_english}
    'Faller';
  {$endif}
  {$ifdef language_dutch}
    'Valler';
  {$endif}

  SFloater =
  {$ifdef language_english}
    'Floater';
  {$endif}
  {$ifdef language_dutch}
    'Zwever';
  {$endif}

  SSplatter =
  {$ifdef language_english}
    'Splatter';
  {$endif}
  {$ifdef language_dutch}
    'Spletter';
  {$endif}

  SExiter =
  {$ifdef language_english}
    'Exiter';
  {$endif}
  {$ifdef language_dutch}
    'Vertrek';
  {$endif}

  SVaporizer =
  {$ifdef language_english}
    'Frier';
  {$endif}
  {$ifdef language_dutch}
    'Bakker';
  {$endif}

  SBlocker =
  {$ifdef language_english}
    'Blocker';
  {$endif}
  {$ifdef language_dutch}
    'Stopper';
  {$endif}

  SShrugger =
  {$ifdef language_english}
    'Shrugger';
  {$endif}
  {$ifdef language_dutch}
    'Kweenie';
  {$endif}

  SOhnoer =
  {$ifdef language_english}
    'Ohnoer';
  {$endif}
  {$ifdef language_dutch}
    'Aiaier';
  {$endif}

  SExploder =
  {$ifdef language_english}
    'Bomber';
  {$endif}
  {$ifdef language_dutch}
    'Ploffer';
  {$endif}

  {-------------------------------------------------------------------------------
    Postview Screen
  -------------------------------------------------------------------------------}
  SYourTimeIsUp =
  {$ifdef language_english}
    'Your time is up!';
  {$endif}
  {$ifdef language_dutch}
    'Je tijd is op!';
  {$endif}

  SAllLemmingsAccountedFor =
  {$ifdef language_english}
    'All lemmings accounted for.';
  {$endif}
  {$ifdef language_dutch}
    'Alle lemmings zijn geteld.';
  {$endif}

  SYouRescuedYouNeeded_ss =
  {$ifdef language_english}
     'You rescued %s' + #13 +
     'You needed  %s';
  {$endif}
  {$ifdef language_dutch}
     'Je hebt gered %s' + #13 +
     'Je had nodig  %s';
  {$endif}

  SResult0 =
  {$ifdef language_english}
    'ROCK BOTTOM! I hope for your sake'      + #13 +
    'that you nuked that level.';
  {$endif}
  {$ifdef language_dutch}
    'ONGELOOFLIJK SLECHT! Misschien moet'  + #13 +
    'je het maar opgeven.';
  {$endif}

  SResult1 =
  {$ifdef language_english}
    'Better rethink your strategy before'    + #13 +
    'you try this level again!';
  {$endif}
  {$ifdef language_dutch}
    'Denk hier nog maar eens goed over na'   + #13 +
    'voordat je het weer probeert!';
  {$endif}

  SResult2 =
  {$ifdef language_english}
    'A little more practice on this level'   + #13 +
    'is definitely recommended.';
  {$endif}
  {$ifdef language_dutch}
    'Je moet meer oefenen op dit spel'       + #13 +
    'anders wordt het niks.';
  {$endif}

  SResult3 =
  {$ifdef language_english}
    'You got pretty close that time.'        + #13 +
    'Now try again for that few % extra.';
  {$endif}
  {$ifdef language_dutch}
    'Je kwam in de buurt deze keer.'         + #13 +
    'Probeer nog eens voor die paar % extra.';
  {$endif}

  SResult4 =
  {$ifdef language_english}
    'OH NO, So near and yet so far (teehee)' + #13 +
    'Maybe this time.....';
  {$endif}
  {$ifdef language_dutch}
    'O NEE, Zo dichtbij en toch zo ver (snik)' + #13 +
    'Mischien deze keer.....';
  {$endif}

  SResult5 =
  {$ifdef language_english}
    'RIGHT ON. You can''t get much closer'   + #13 +
    'than that. Let''s try the next...';
  {$endif}
  {$ifdef language_dutch}
    'OKIDOKI. Veel preciezer dan dit kan'   + #13 +
    'het niet. Probeer de volgende maar...';
  {$endif}

  SResult6 =
  {$ifdef language_english}
    'That level seemed no problem to you on' + #13 +
    'that attempt. Onto the next....';
  {$endif}
  {$ifdef language_dutch}
    'Dit leek geen problemen op te leveren' + #13 +
    'deze keer. Op naar de volgende....';
  {$endif}

  SResult7 =
  {$ifdef language_english}
    'You totally stormed that level!'        + #13 +
    'Let''s see if you can storm the next...';
  {$endif}
  {$ifdef language_dutch}
    'Je hebt dit nivo gekraakt! Laten we'    + #13 +
    'kijken of je de volgende kan kraken...';
  {$endif}

  SResult8 =
  {$ifdef language_english}
    'Superb! You rescued every lemmings on' + #13 +
    'that level. Can you do it again....';
  {$endif}
  {$ifdef language_dutch}
    'Geweldig! Je hebt alle lemmings in dit' + #13 +
    'spel gered. Kun je dat nog eens....';
  {$endif}

  SCongratulationOrig =
  {$ifdef language_english}
    #13 + #13 +
    'Congratulations!' +
    #13 + #13 + #13 + #13 + #13 +
    'Everybody here at DMA Design salutes you' + #13 +
    'as a MASTER Lemmings player. Not many' + #13 +
    'people will complete the Mayhem levels,' + #13 +
    'you are definitely one of the elite' + #13 +
    #13 + #13 + #13 + #13 + #13 +
    'Now hold your breath for the data disk';
  {$endif}
  {$ifdef language_dutch}
    #13 + #13 +
    'Congratulations!' +
    #13 + #13 + #13 + #13 + #13 +
    'Everybody here at DMA Design salutes you' + #13 +
    'as a MASTER Lemmings player. Not many' + #13 +
    'people will complete the Mayhem levels,' + #13 +
    'you are definitely one of the elite' + #13 +
    #13 + #13 + #13 + #13 + #13 +
    'Now hold your breath for the data disk';
  {$endif}


  SResultOhNo0 =
  {$ifdef language_english}
    'Oh dear, not even one poor Lemming'   + #13 +
    'saved. Try a little harder next time.';
  {$endif}
  {$ifdef language_dutch}
    'Mijn hemel, niet n lemming gered.'  + #13 +
    'Dit slaat echt nergens op.';
  {$endif}

  SResultOhNo1 =
  {$ifdef language_english}
    'Yes, well, err, erm, maybe that is' + #13 +
    'NOT the way to do this level.';
  {$endif}
  {$ifdef language_dutch}
    'Tja, hm, eh, misschien is dit' + #13 +
    'NIET de manier om dit spel te doen.';
  {$endif}

  SResultOhNo2 =
  {$ifdef language_english}
    'We are not too impressed with your' + #13 +
    'attempt at that level!';
  {$endif}
  {$ifdef language_dutch}
    'Wij zijn niet onder de indruk van' + #13 +
    'deze poging!';
  {$endif}

  SResultOhNo3 =
  {$ifdef language_english}
    'Getting close. You are either pretty' + #13 +
    'good, or simply lucky.';
  {$endif}
  {$ifdef language_dutch}
    'Je komt in de buurt. Je bent best goed' + #13 +
    'of je hebt gewoon geluk.';
  {$endif}

  SResultOhNo4 =
  {$ifdef language_english}
    'Shame, You were short by a tiny amount.' + #13 +
    'Go for it this time.';
  {$endif}
  {$ifdef language_dutch}
    nederlands
  {$endif}

  SResultOhNo5 =
  {$ifdef language_english}
    'Just made it by the skin of your' + #13 +
    'teeth. Time to progress..';
  {$endif}
  {$ifdef language_dutch}
    nederlands
  {$endif}

  SResultOhNo6 =
  {$ifdef language_english}
    // This seems a typo but it really is enough+space + point in the exe
    'More than enough .You have the makings' + #13 +
    'of a master Lemmings player.';
  {$endif}
  {$ifdef language_dutch}
    nederlands
  {$endif}

  SResultOhNo7 =
  {$ifdef language_english}
    'What a fine display of Lemmings control.' + #13 +
    'Take a bow then carry on with the game.';
  {$endif}
  {$ifdef language_dutch}
    nederlands
  {$endif}

  SResultOhNo8 =
  {$ifdef language_english}
    'WOW! You saved every Lemming.' + #13 +
    'TOTALLY EXCELLENT!';
  {$endif}
  {$ifdef language_dutch}
    nederlands
  {$endif}

  SCongratulationOhNo =
  {$ifdef language_english}
    #13 + #13 +
    'Congratulations!' + #13 +
    #13 + #13 + #13 + #13 + #13 +
    'You are truly an Excellent' + #13 +
    'Lemmings player' + #13 +
    #13 +
    'The Lemmings Saga continues at a' + #13 +
    'later date, watch this space';
  {$endif}
  {$ifdef language_dutch}
    'Gefeliciteerd!';
  {$endif}


  SYourAccessCode_ds =
  {$ifdef language_english}
    'Your Access Code for Level %d' + #13 +
    'is %s';
  {$endif}
  {$ifdef language_dutch}
    'Je Toegangs Code voor Spel %d' + #13 +
    'is %s';
  {$endif}


  SPressLeftMouseForNextLevel =
  {$ifdef language_english}
    'Press left mouse button for next level';
  {$endif}
  {$ifdef language_dutch}
    'Klik linker muis knop voor volgend spel';
  {$endif}

  SPressLeftMouseToRetryLevel =
  {$ifdef language_english}
    'Press left mouse button to retry level';
  {$endif}
  {$ifdef language_dutch}
    'Klik linker muis knop voor herkansing';
  {$endif}

  SPressRightMouseForMenu =
  {$ifdef language_english}
    'Press right mouse button for menu';
  {$endif}
  {$ifdef language_dutch}
    'Klik rechter muis knop voor menu';
  {$endif}

  SPressMouseToContinue =
  {$ifdef language_english}
    'Press mouse button to continue';
  {$endif}
  {$ifdef language_dutch}
    'Klik muis knop om door te gaan';
  {$endif}

  {-------------------------------------------------------------------------------
    SkillPanel hints (not used yet)
  -------------------------------------------------------------------------------}
  SDigHint =
  {$ifdef language_english}
    'Dig';
  {$endif}
  {$ifdef language_dutch}
    'Graven';
  {$endif}

  SClimbHint =
  {$ifdef language_english}
    'Climb';
  {$endif}
  {$ifdef language_dutch}
    'Klimmen';
  {$endif}

  SBuildHint =
  {$ifdef language_english}
    'Build';
  {$endif}
  {$ifdef language_dutch}
    'Bouwen';
  {$endif}

  SBashHint =
  {$ifdef language_english}
    'Bash';
  {$endif}
  {$ifdef language_dutch}
    'Breken';
  {$endif}

  SMineHint =
  {$ifdef language_english}
    'Mine';
  {$endif}
  {$ifdef language_dutch}
    'Hakken';
  {$endif}

  SFloatHint =
  {$ifdef language_english}
    'Umbrella';
  {$endif}
  {$ifdef language_dutch}
    'Paraplu';
  {$endif}

  SBlockHint =
  {$ifdef language_english}
    'Block';
  {$endif}
  {$ifdef language_dutch}
    'Stoppen';
  {$endif}

  SExplodeHint =
  {$ifdef language_english}
    'Bomb';
  {$endif}
  {$ifdef language_dutch}
    'Ontploffen';
  {$endif}

const
  LemmingActionStrings: array[TBasicLemmingAction] of string = (
    SDummyString,
    SWalker,
    SJumper,
    SDigger,
    SClimber,
    SDrowner,
    SHoister,
    SBuilder,
    SBasher,
    SMiner,
    SFaller,
    SFloater,
    SSplatter,
    SExiter,
    SVaporizer,
    SBlocker,
    SShrugger,
    SOhnoer,
    SExploder
  );

  //@styledef
  {$ifdef orig}
  ResultStrings: array[0..8] of string = (
    SResult0,
    SResult1,
    SResult2,
    SResult3,
    SResult4,
    SResult5,
    SResult6,
    SResult7,
    SResult8
  );
  SCongrats: string = SCongratulationOrig;
  {$endif}

  {$ifdef ohno}
  ResultStrings: array[0..8] of string = (
    SResultOhNo0,
    SResultOhNo1,
    SResultOhNo2,
    SResultOhNo3,
    SResultOhNo4,
    SResultOhNo5,
    SResultOhNo6,
    SResultOhNo7,
    SResultOhNo8
  );
  SCongrats: string = SCongratulationOhNo;
  {$endif}

  {$ifdef h93}
  {TODO: check this ones out}
  ResultStrings: array[0..8] of string = (
    SResultOhNo0,
    SResultOhNo1,
    SResultOhNo2,
    SResultOhNo3,
    SResultOhNo4,
    SResultOhNo5,
    SResultOhNo6,
    SResultOhNo7,
    SResultOhNo8
  );
  SCongrats: string = SCongratulationOhNo;
  {$endif}

  {$ifdef remake}
  ResultStrings: array[0..8] of string = (
    SResultOhNo0,
    SResultOhNo1,
    SResultOhNo2,
    SResultOhNo3,
    SResultOhNo4,
    SResultOhNo5,
    SResultOhNo6,
    SResultOhNo7,
    SResultOhNo8
  );
  SCongrats: string = SCongratulationOhNo;
  {$endif}

implementation

end.


